Imports DotNetNuke.UI.Utilities
Imports DotNetNuke.Security

Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Entities.Modules.Actions

Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Services.Localization

Imports Aricie.ComponentModel

Imports Aricie.DNN.Security.Trial
Imports Aricie.DNN.Settings
Imports Aricie.DNN.Services
Imports Aricie.DNN.UI.Controls
Imports Aricie.Web.UI.Controls.GridViewGrouping

Imports LSCommon = Aricie.DNN.Modules.LuceneSearch.Common
Imports Aricie.DNN.Modules.LuceneSearch.Security
Imports Aricie.DNN.Modules.LuceneSearch.Business
Imports Aricie.DNN.Modules.LuceneSearch.Settings

Imports Lucene.Net.Search

Imports System.Data
Imports DotNetNuke.UI.Skins
Imports DotNetNuke.UI.Skins.Controls
Imports DotNetNuke.Common.Globals
Imports System.IO

Imports System.Linq

Namespace Aricie.DNN.Modules.LuceneSearch.UI

    Partial Public Class AricieLuceneSearchResults
        Inherits LuceneModuleBase
        Implements IActionable

        Private WithEvents ctlResults As ILuceneResultsControl

        Private Property IsReturnFromDetail() As Boolean
            Get
                Dim toReturn As Boolean = False
                If Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) IsNot Nothing Then
                    If Me.ViewState("IsReturnFromDetail") IsNot Nothing Then
                        toReturn = Convert.ToBoolean(Me.ViewState("IsReturnFromDetail"))
                    Else
                        toReturn = Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) = "back"
                    End If
                End If
                Return toReturn
            End Get
            Set(ByVal value As Boolean)
                Me.ViewState("IsReturnFromDetail") = value
            End Set
        End Property

        Public Property QueryFromUrl As LuceneFilterQuery
            Get
                Dim obj As Object = ViewState("QueryFromUrl")
                If (obj IsNot Nothing) Then
                    Return DirectCast(obj, LuceneFilterQuery)
                End If
                Return Nothing
            End Get
            Set(value As LuceneFilterQuery)
                ViewState("QueryFromUrl") = value
            End Set
        End Property

        Public ReadOnly Property DisplayingPrintingMode As Boolean
            Get
                Return Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) IsNot Nothing _
                    AndAlso Me.Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) = LSCommon.Constants.UrlParameters.PrintMode
            End Get
        End Property

        Private Property ResultsFound As Integer
        Private Property CurrentPageIndex As Integer

        Private Property SearchHappened As Boolean
            Get
                Dim toReturn As Boolean = False
                If Not ViewState("SearchHappened") Is Nothing Then
                    toReturn = CBool(ViewState("SearchHappened"))
                End If
                

                Return toReturn
            End Get
            Set(ByVal value As Boolean)
                ViewState("SearchHappened") = value
            End Set
        End Property

#Region "Initialisation"
        Private Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
            SetupAjaxHistory()
            LoadFilter()
        End Sub


        Sub SetupAjaxHistory()
            Dim sm As ScriptManager = ScriptManager.GetCurrent(Me.Page)
            If sm IsNot Nothing Then
                'sm.EnableHistory = True
                'sm.EnableSecureHistoryState = False
            End If
        End Sub

        Sub RetrieveQueryFromUrl()
            ' on rcupre les informations provenant de l'url
            If (Not IsPostBack) Then
                Dim query As New LuceneFilterQuery
                query.FilterQuery = BusinessController.GetQuery(PortalId, IUrlParametersProcessorFactory.Instance.RetrieveParameter(Common.Constants.Http.FilterCriteria))
                query.SearchQuery = IUrlParametersProcessorFactory.Instance.RetrieveParameter(Common.Constants.Http.SearchCriteria)
                QueryFromUrl = query
            End If
        End Sub

        Private Sub LoadFilter()
            Try
                If LuceneResultsSettings.FiltersDisplayed Then
                    Dim myCtl As Control = LoadControl(LuceneResultsSettings.FilterToLoad)
                    myCtl.ID = "ctlFilterControl"
                    ctlFilterPanel.Controls.Add(myCtl)


                    'TODO: rappliquer les settings  partir du bon endroit
                    Dim lucenePortalSetts As LucenePortalSettings = GetModuleSettings(Of LucenePortalSettings)(SettingsScope.PortalSettings, PortalId)
                    ctlFilterPanel.MakeLog = lucenePortalSetts.EnableFilterLogging
                End If

            Catch ex As Exception
                Dim myErrorCtl As New Label
                myErrorCtl.Text = ex.Message
                ctlFilterPanel.Controls.Add(myErrorCtl)
            End Try
        End Sub

#End Region

        Private Sub SetupModuleInstallationDisplay()
            pnMain.Visible = False
            Dim configurationControl As Control = LoadControl("ConfigurationInstall.ascx")
            DirectCast(configurationControl, PortalModuleBase).LocalResourceFile = LocalResourceFile.Replace("AricieLuceneSearchResults", "ConfigurationInstall")

            Controls.Add(configurationControl)
        End Sub

        Private Sub CheckModuleVersionNumberInstalled()
            ' uniquement pour nous sur LuceneSearch
#If DEBUG Then
            Dim DMC As New DesktopModuleController()
            Dim DMI = DMC.GetDesktopModuleByModuleName(Aricie.DNN.Modules.LuceneSearch.Common.Constants.ModuleNameLuceneSearchResults)

            If (Global.UpgradeSystem.VersionManagement.InstalledVersion.CurrentlyInstalledVersion.Version <> DMI.Version) Then
                pnMain.Visible = False
                Controls.Add(LoadControl("Controls/Settings/Upgrade/LuceneSearchUpgradeControl.ascx"))
            End If
#Else
                    Dim ChangedVersion = Global.UpgradeSystem.VersionManagement.InstalledVersion.CurrentlyInstalledVersion
                    Dim DMC As New DesktopModuleController()
                    Dim DMI = DMC.GetDesktopModuleByModuleName(Aricie.DNN.Modules.LuceneSearch.Common.Constants.ModuleNameLuceneSearchResults)
                    If (DMI.Version <> ChangedVersion.Version) Then
                        ChangedVersion.Version = DMI.Version
                        ChangedVersion.InstalledDate = DateTime.Now
                        Global.UpgradeSystem.VersionManagement.InstalledVersion.CurrentlyInstalledVersion = ChangedVersion
                    End If

#End If
        End Sub

        Protected Overrides Sub OnLoad(e As System.EventArgs)

            If Not BusinessController.IsLuceneProviderInstalled Then
                SetupModuleInstallationDisplay()
                Exit Sub
            Else
                CheckModuleVersionNumberInstalled()
#If DEBUG Then
                ' we load a different module if it's the debug mode so we exit here
                If Not pnMain.Visible Then
                    Exit Sub
                End If

#End If
            End If

            MyBase.OnLoad(e)
            Try
                Dim filtersGotInfoFromTheUrl As Boolean = False
                If Not IsPostBack Then
                    RetrieveQueryFromUrl()
                    If LuceneResultsSettings.FiltersDisplayed Then
                        filtersGotInfoFromTheUrl = ctlFilterPanel.ParseFilter(QueryFromUrl)
                    End If
                End If

                If Not String.IsNullOrEmpty(LuceneResultsSettings.TemplateConfiguration.ResultsControlPath) Then
                    Try
                        ctlResults = DirectCast(LoadControl(LuceneResultsSettings.TemplateConfiguration.ResultsControlPath), ILuceneResultsControl)
                    Catch ex As Exception
                        LogException(ex)
                        lblNoResult.Text = Localization.GetString("lblNoResultControl.Text", Me.LocalResourceFile)
                        Exit Sub
                    End Try
                End If

                If ctlResults IsNot Nothing Then
                    AddHandler ctlResults.RefreshData, AddressOf ctlResults_RefreshData
                    phResults.Controls.Add(DirectCast(ctlResults, Control))

                    If DisplayingPrintingMode Then
                        Dim PrintingScript As String = "function PrintWindow(){ window.print(); }function CheckWindowState(){ if(document.readyState==""complete""){window.close(); }else{ setTimeout(""CheckWindowState()"", 2000)}} $(document).ready(PrintWindow())"
                        ScriptManager.RegisterStartupScript(Me, Me.GetType, "PrintingMode" & Now.Ticks.ToString, PrintingScript, True)

                    End If
                End If

                If Not IsPostBack Then
                    ctlResults.RetrieveUrlInformation()
                    'ctlResults
                End If

                ' on lance la recherche directement dans les cas suivants:
                '   Si on montre les rsultats 
                '       - Si on est en ajax
                '           - Si on est pas dans un postback
                '               - Si on doit afficher les rsultats sans recherche
                '               OU
                '               - si on est en mode impression
                '       - si on est pas en ajax
                '           - que la requte est renseigne (parse ou non)
                '           OU
                '           - si on doit afficher les rsultats sans recherche
                '           OU
                '           - si on veut lancer la recherche (parametre qui force la recherche dans l'URL)
                '

                Dim searchIsVisibleBecauseWeShowTheResults As Boolean = LuceneResultsSettings.ShowResults
                Dim forceSearch As Boolean = False
                If Not String.IsNullOrEmpty(Request.Params(LSCommon.Constants.Http.LaunchSearch)) Then
                    forceSearch = CBool(Request.Params(LSCommon.Constants.Http.LaunchSearch))
                End If
                Dim searchMustBeLaunchedDirectly As Boolean = ((Not LuceneResultsSettings.DisplayResultsOnlyWhereSearch _
                        OrElse (DisplayingPrintingMode AndAlso LuceneResultsSettings.AllowPrint)) Or forceSearch)

                Dim moduleHasSearchParameters As Boolean = filtersGotInfoFromTheUrl OrElse QueryFromUrl.HasInfo

                Dim ajaxQueryIsValid As Boolean = LuceneResultsSettings.EnableAjax AndAlso Not IsPostBack AndAlso (moduleHasSearchParameters OrElse searchMustBeLaunchedDirectly)
                Dim directQueryIsValid As Boolean = Not LuceneResultsSettings.EnableAjax AndAlso (moduleHasSearchParameters OrElse searchMustBeLaunchedDirectly)

                Dim isBack As Boolean = False
                If Not String.IsNullOrEmpty(Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter)) Then
                    If Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) = "back" Then
                        isBack = True
                    End If
                End If
                If (searchIsVisibleBecauseWeShowTheResults AndAlso (ajaxQueryIsValid OrElse directQueryIsValid)) Or isBack Then
                    SearchTriggered()
                End If

                ' si jamais c'est l'administrateur qui regarde cette page, et que les filtres n'ont pas repris l'intgralit des donnes passes dans l'url
                ' on l'informe qu'il se peut que ce soit un problme de paramtrage
                If QueryFromUrl.HasInfo AndAlso (User.IsSuperUser OrElse User.IsInRole("Administrators")) AndAlso LuceneResultsSettings.EnableWarningsFromUrlFiltering Then
                    Skin.AddModuleMessage(Me, Localization.GetString("FiltersNotPickedUp", Me.LocalResourceFile), ModuleMessage.ModuleMessageType.YellowWarning)
                End If

            Catch ex As Exception
                ProcessModuleLoadException(DirectCast(Me, PortalModuleBase), ex)
            End Try
        End Sub


#Region "Actions"

        Private Sub SearchTriggered()
            ' une recherche vient d'tre demande: recherche = click sur un bouton ou recherche automatique en arrivant sur cette page
            ctlResults.LuceneFilterQuery = MergeFilterQueries()

            If LuceneResultsSettings.EnableAjax OrElse Not IsPostBack Then

                ctlResults.FilterSort = String.Join(",", ctlFilterPanel.GetCustomSortExpression().ToArray())

                ' si on est en ajax, on refait un bind en fournissant les nouvelles informations de filtres
                Dim SP As New SearchParams() With {.NeedNewBind = True _
                                                  , .LuceneFilterQuery = ctlResults.LuceneFilterQuery _
                                                  , .PageIndex = ctlResults.PageIndex _
                                                  , .PageSize = ctlResults.PageSize _
                                                  , .SortField = ctlResults.GetSortParameter()}
                BindResults(SP)
            Else
                ' si on est pas en ajax, on redirige vers l'url correcte
                ManageSearchRedirection(ctlResults.LuceneFilterQuery, 1)
            End If
        End Sub

        Private Function MergeFilterQueries() As LuceneFilterQuery
            Dim filterPanelQuery As LuceneFilterQuery = ctlFilterPanel.GetFilter
            Dim urlQuery As LuceneFilterQuery = QueryFromUrl

            Dim mergedQuery As New LuceneFilterQuery
            If (filterPanelQuery.SearchQuery IsNot Nothing) Then
                mergedQuery.SearchQuery = filterPanelQuery.SearchQuery
            ElseIf (urlQuery.SearchQuery IsNot Nothing) Then
                mergedQuery.SearchQuery = urlQuery.SearchQuery
            End If

            Dim MergedBQ As New BooleanQuery
            If filterPanelQuery.FilterQuery IsNot Nothing AndAlso TypeOf filterPanelQuery.FilterQuery Is BooleanQuery Then
                For Each Clause As BooleanClause In DirectCast(filterPanelQuery.FilterQuery, BooleanQuery).Clauses
                    MergedBQ.Add(Clause)
                Next
            End If

            If urlQuery.FilterQuery IsNot Nothing AndAlso TypeOf urlQuery.FilterQuery Is BooleanQuery Then
                For Each Clause As BooleanClause In DirectCast(urlQuery.FilterQuery, BooleanQuery).Clauses
                    MergedBQ.Add(Clause)
                Next
            End If

            If (MergedBQ.Clauses.Count > 0) Then
                mergedQuery.FilterQuery = MergedBQ
            Else
                mergedQuery.FilterQuery = Nothing
            End If

            Return mergedQuery
        End Function

        Protected Sub cmdSearch_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdSearch.Click
            Try
                If ctlResults IsNot Nothing Then
                    ctlResults.PageIndex = 0 ' force the user back to the first page
                End If
                SearchTriggered()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

        Private Sub ctlFilterPanel_FilterChanged(ByVal sender As Object, ByVal e As GenericEventArgs(Of LuceneFilterQuery)) Handles ctlFilterPanel.FilterChanged
            Try
                ctlResults.PageIndex = 0 ' force the user back to the first page
                SearchTriggered()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try

        End Sub

        Private Sub cmdReset_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdReset.Click
            Response.Redirect(NavigateURL())
        End Sub

        Protected Sub ctlResults_RefreshData(ByVal sender As Object, ByVal e As GenericEventArgs(Of SearchParams))
            If Not LuceneResultsSettings.EnableAjax AndAlso IsPostBack Then
                ManageSearchRedirection(e.Item.LuceneFilterQuery, e.Item.PageIndex + 1)
            End If
            ' si on est pas en ajax le thread ne va pas s'arrter et donc pourra binder les rsultats
            BindResults(e.Item)
        End Sub

        Private Sub AddUrlParameterIfNotEmpty(ParameterList As List(Of String), value As String, ParameterName As String)
            If (Not String.IsNullOrEmpty(value)) Then
                ParameterList.Add(IUrlParametersProcessorFactory.Instance.CreateParameter(ParameterName, value))
            End If
        End Sub


        Private Sub ManageSearchRedirection(CurrentLuceneFilterQuery As LuceneFilterQuery, CurrentPageIndex As Integer)
            Dim ParameterList As New List(Of String)
            If (CurrentLuceneFilterQuery.SearchQuery IsNot Nothing) Then
                ParameterList.Add(IUrlParametersProcessorFactory.Instance.CreateParameter(LSCommon.Constants.Http.SearchCriteria, CurrentLuceneFilterQuery.SearchQuery))
            Else
                ParameterList.Add(IUrlParametersProcessorFactory.Instance.CreateParameter(LSCommon.Constants.Http.LaunchSearch, CStr(True))) 'parametre qui force le lancement de la recherche
            End If
            Dim Filter As String = String.Empty
            If CurrentLuceneFilterQuery.FilterQuery IsNot Nothing Then
                Filter = CurrentLuceneFilterQuery.FilterQuery.ToString()
            End If

            AddUrlParameterIfNotEmpty(ParameterList, Filter, LSCommon.Constants.Http.FilterCriteria)
            AddUrlParameterIfNotEmpty(ParameterList, ctlResults.Grouping, LSCommon.Constants.UrlResultsParameters.ResultsPageGroup)
            AddUrlParameterIfNotEmpty(ParameterList, ctlResults.PageSize.ToString(), LSCommon.Constants.UrlResultsParameters.ResultsPageSize)
            AddUrlParameterIfNotEmpty(ParameterList, ctlResults.Sort, LSCommon.Constants.UrlResultsParameters.ResultsPageSort)
            ' on rajoute les informations du tri provenant des filtres dans l'url
            AddUrlParameterIfNotEmpty(ParameterList, String.Join(",", ctlFilterPanel.GetCustomSortExpression().ToArray()), LSCommon.Constants.UrlResultsParameters.ResultsFilterSort)

            If (CurrentPageIndex > 1) Then
                ParameterList.Add(IUrlParametersProcessorFactory.Instance.CreateParameter(LSCommon.Constants.UrlResultsParameters.ResultsPageIndex, CurrentPageIndex.ToString))
            End If

            ' si la redirection demande est une redirection d'impression, il faut qu'on gre les paramtres pour l'impression
            If DisplayingPrintingMode Then
                ParameterList.Add(String.Format("{0}={1}", LSCommon.Constants.UrlParameters.LuceneSearchModeParameter, LSCommon.Constants.UrlParameters.PrintMode))
                ParameterList.Add(String.Format("{0}={1}", "mid", ModuleId))
                If LuceneResultsSettings.DisableSkinForPrintResult Then
                    ParameterList.Add("ContainerSrc=[G]Containers/_default/No+Container")
                    ParameterList.Add("SkinSrc=[G]Skins/_default/No+Skin")
                End If
            End If

            Response.Redirect(NavigateURL(Convert.ToInt32(IIf(LuceneResultsSettings.ResultsTabId <> -1, LuceneResultsSettings.ResultsTabId, TabId)), String.Empty, ParameterList.ToArray()), True)
        End Sub


        Private Sub Page_PreRender(ByVal sender As Object, ByVal e As EventArgs) Handles Me.PreRender
            Try
                ' on gre l'affichage globalement dans le prerender

                'panneau de recherche
                LS_SearchPanel.Visible = LuceneResultsSettings.SearchPanelDisplayed

                ' en-tte de zone recherche
                shSearch.Visible = LuceneResultsSettings.SearchMinificationDisplayed

                ' filtres
                ctlFilterPanel.Enabled = Not DisplayingPrintingMode

                ' commandes
                cmdSearch.Visible = LuceneResultsSettings.SearchButtonDisplayed AndAlso Not DisplayingPrintingMode
                cmdReset.Visible = LuceneResultsSettings.ResetButtonDisplayed AndAlso Not DisplayingPrintingMode

                ' lments d'impression
                lnkResultPrint.Visible = LuceneResultsSettings.AllowPrint AndAlso ResultsFound > 0 AndAlso Not DisplayingPrintingMode
                lnkResultPrintBas.Visible = LuceneResultsSettings.AllowPrint AndAlso ResultsFound > 0 AndAlso Not DisplayingPrintingMode
                If (lnkResultPrint.Visible) AndAlso (lnkResultPrintBas.Visible) Then
                    ' si le lien est visible, remplissons le
                    BuildPrintLink(MergeFilterQueries())
                End If

                ' en-tte de rsultats de recherche, seulement si une recherche a eu lieu
                shResults.Visible = LuceneResultsSettings.AllowMinimizeResults AndAlso SearchHappened

                ' rsultats, seulement si une recherche a eu lieu
                pnlAllResults.Visible = LuceneResultsSettings.ShowResults AndAlso SearchHappened

                ' si un paramtre tag existe dans l'url, on cache les lments
                'TODO: demander quel est l'intrt de ce rglage
                If Not String.IsNullOrEmpty(IUrlParametersProcessorFactory.Instance.RetrieveParameter("Tag")) Then
                    If IsEditable Then
                        Skin.AddModuleMessage(Me, Localization.GetString("ModuleHidden", Me.LocalResourceFile), ModuleMessage.ModuleMessageType.RedError)
                        pnMain.Visible = False
                    Else
                        ContainerControl.Visible = False
                    End If
                End If

            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try

        End Sub

#End Region

#Region "Private methods"

        Private Sub BindResults(ByVal objSearchParams As SearchParams)

            CurrentPageIndex = objSearchParams.PageIndex

            If LuceneResultsSettings.ShowResults Then

                'Rcupration des rsultats
                Dim printMode As Boolean = False
                Dim blockRedirectToResult As Boolean = False
                If Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) IsNot Nothing _
                    AndAlso Session(LSCommon.Constants.LS_SEARCHSESSION) IsNot Nothing Then

                    If DisplayingPrintingMode Then
                        'objSearchParams = (DirectCast(Session(LSCommon.Constants.LS_SEARCHSESSION), SearchParams))
                        If Me.LuceneResultsSettings.DisablePagingForPrint Then
                            objSearchParams.PageSize = 0
                            objSearchParams.PageIndex = 0
                        End If
                        printMode = True
                    End If

                    If IsReturnFromDetail Then
                        If Me.ModuleId = CInt(Session(LSCommon.Constants.LS_SEARCHTABID).ToString.Split(";"c)(1)) Then
                            objSearchParams = (DirectCast(Session(LSCommon.Constants.LS_SEARCHSESSION), SearchParams))
                            IsReturnFromDetail = False
                            blockRedirectToResult = True
                        End If
                    End If
                End If


                Dim results As IList(Of LuceneSearchResultsInfo) = SearchController.GetResults(Me.PortalId, Me.ModuleId, objSearchParams, ResultsFound)

                'Sauvegarde de la recherche en session
                If (Me.LuceneResultsSettings.AllowPrint OrElse Me.LuceneResultsSettings.DisplayBackButton) AndAlso ResultsFound > 0 Then
                    Session(LSCommon.Constants.LS_SEARCHSESSION) = objSearchParams
                End If
                'Sauvegarde du module ayant dclench la recherche en session
                If Me.LuceneResultsSettings.DisplayBackButton AndAlso ResultsFound > 0 Then
                    Session(LSCommon.Constants.LS_SEARCHTABID) = Me.TabId & ";" & Me.ModuleId
                End If


                If Me.LuceneResultsSettings.RedirectIfOnlyOneResult AndAlso ResultsFound = 1 AndAlso Not blockRedirectToResult AndAlso objSearchParams.NeedNewBind Then
                    Dim resUpdated As LuceneSearchResultsInfo = results(0)
                    If resUpdated.ModuleId = Aricie.DNN.Modules.LuceneSearch.Common.Constants.SearchAndResultItemInfos.ModuleIdCannotBeDetermined Then ' modification intgre suite  correction de Jeremy sur FFB
                        If Me.LuceneResultsSettings.EnableAjax Then
                            resUpdated.TabId = Me.TabId
                        Else
                            resUpdated.TabId = Me.LuceneResultsSettings.ResultsTabId
                        End If
                    End If
                    RedirectToResult(resUpdated) 'redirection si un rsultat
                End If

                ctlResults.LuceneFilterQuery = objSearchParams.LuceneFilterQuery
                ctlResults.DisplayResults(results, ResultsFound, objSearchParams.SortField, printMode, objSearchParams.PageIndex)
                DisplayNbResults(ResultsFound, objSearchParams.PageSize, printMode)

                objSearchParams.NeedNewBind = False

                SearchHappened = True
            End If

        End Sub

        'Private Sub smpHistory_Navigate(sender As Object, e As System.Web.UI.HistoryEventArgs) Handles smpHistory.Navigate
        '    Dim sm As ScriptManager = ScriptManager.GetCurrent(Me.Page)
        '    If sm IsNot Nothing AndAlso sm.IsNavigating Then
        '        UrlPageIndex = Convert.ToInt32(e.State(LSCommon.Constants.PageIndexUrlParameterName))
        '        Dim query As New LuceneFilterQuery
        '        query.FilterQuery = BusinessController.GetQuery(PortalId, e.State(Common.Constants.Http.FilterCriteria))
        '        query.SearchQuery = e.State(Common.Constants.Http.SearchCriteria)
        '        QueryFromUrl = query
        '        SearchTriggered()
        '        Dim UpdatePanelContainer As Control = Me
        '        While UpdatePanelContainer IsNot Nothing AndAlso Not TypeOf UpdatePanelContainer Is UpdatePanel
        '            UpdatePanelContainer = UpdatePanelContainer.Parent
        '        End While
        '        If UpdatePanelContainer IsNot Nothing Then
        '            DirectCast(UpdatePanelContainer, UpdatePanel).Update()
        '        End If
        '    End If

        'End Sub

        Private Sub DisplayNbResults(ByVal nbResults As Integer, ByVal pageSize As Integer, ByVal printMode As Boolean)
            If nbResults = 0 Then
                lblNoResult.Text = Localization.GetString("lblNoResult.Text", Me.LocalResourceFile)
                lblNbPagesResult.Visible = False
                lnkResultPrint.Visible = False
                lnkResultPrintBas.Visible = False
            Else
                If Me.LuceneResultsSettings.DisplayNbResults Then
                    lblNoResult.Text = Localization.GetString("lblNbResults.Text", Me.LocalResourceFile).Replace("[NbResults]", nbResults.ToString)
                Else
                    lblNoResult.Text = ""
                End If
                If Me.LuceneResultsSettings.DisplayNbPagesResults AndAlso Me.LuceneResultsSettings.EnablePaging AndAlso Not (printMode AndAlso Me.LuceneResultsSettings.DisablePagingForPrint) Then
                    Dim doubleNbResults As Double = CType(nbResults, Double)
                    Dim doubleDefaultPageSize As Double
                    Dim nbPages As Integer = 0
                    If Me.LuceneResultsSettings.AllowCustomPageSize Then
                        If CType(pageSize, Double) < 1.0 Then
                            nbPages = 1
                        Else
                            doubleDefaultPageSize = CType(pageSize, Double)
                        End If

                    Else
                        doubleDefaultPageSize = CType(Me.LuceneResultsSettings.DefaultPageSize, Double)
                    End If

                    If Not nbPages = 1 Then
                        'Arrondi au suprieur
                        nbPages = CInt(IIf(Int(doubleNbResults / doubleDefaultPageSize) = doubleNbResults / doubleDefaultPageSize, doubleNbResults / doubleDefaultPageSize, Int(doubleNbResults / doubleDefaultPageSize) + 1))
                        lblNbPagesResult.Visible = True
                    End If
                    lblNbPagesResult.Text = Localization.GetString("lblNbPagesResult.Text", Me.LocalResourceFile).Replace("[NbPagesResults]", nbPages.ToString)
                Else
                    lblNbPagesResult.Text = ""
                End If
            End If
        End Sub

        Private Sub BuildPrintLink(LFQ As LuceneFilterQuery)
            Dim ParameterList As New List(Of String)

            If (Not String.IsNullOrEmpty(LFQ.SearchQuery)) Then
                ParameterList.Add(IUrlParametersProcessorFactory.Instance.CreateParameter(LSCommon.Constants.Http.SearchCriteria, LFQ.SearchQuery))
            End If
            Dim Filter As String = String.Empty
            If LFQ.FilterQuery IsNot Nothing Then
                Filter = LFQ.FilterQuery.ToString()
            End If

            ParameterList.Add(String.Format("{0}={1}", LSCommon.Constants.UrlParameters.LuceneSearchModeParameter, LSCommon.Constants.UrlParameters.PrintMode))
            ParameterList.Add(String.Format("{0}={1}", "mid", ModuleId))
            ParameterList.Add(String.Format("{0}={1}", LSCommon.Constants.UrlResultsParameters.ResultsPageIndex, CurrentPageIndex + 1))

            AddUrlParameterIfNotEmpty(ParameterList, Filter, LSCommon.Constants.Http.FilterCriteria)
            AddUrlParameterIfNotEmpty(ParameterList, ctlResults.Grouping, LSCommon.Constants.UrlResultsParameters.ResultsPageGroup)
            AddUrlParameterIfNotEmpty(ParameterList, ctlResults.PageSize.ToString(), LSCommon.Constants.UrlResultsParameters.ResultsPageSize)
            AddUrlParameterIfNotEmpty(ParameterList, ctlResults.Sort, LSCommon.Constants.UrlResultsParameters.ResultsPageSort)

            If LuceneResultsSettings.DisableSkinForPrintResult Then
                ParameterList.Add("ContainerSrc=[G]Containers/_default/No+Container")
                ParameterList.Add("SkinSrc=[G]Skins/_default/No+Skin")
            End If

            lnkResultPrint.NavigateUrl = NavigateURL(Me.TabId, String.Empty, ParameterList.ToArray())
            lnkResultPrintBas.NavigateUrl = NavigateURL(Me.TabId, String.Empty, ParameterList.ToArray())
        End Sub

        Private Sub RedirectToResult(ByVal result As LuceneSearchResultsInfo)

            If result.ModuleId > 0 Then
                Response.Redirect(result.GoToUrl)
            Else
                Dim strDetails As String = ""
                If LuceneResultsSettings.DisplayBackButton Then
                    strDetails = String.Format(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter + "={0}", "detail")
                End If
                Response.Redirect(DotNetNuke.Common.NavigateURL(result.TabId, "ResultDetails", New String() {String.Format("mid={0}", Me.ModuleId), strDetails, String.Format("guid={0}", DotNetNuke.Common.Utilities.UrlUtils.EncryptParameter(result.Guid))}))
            End If

        End Sub

#End Region


#Region "IActionable members"

        Public ReadOnly Property ModuleActions() As ModuleActionCollection Implements IActionable.ModuleActions

            Get
                Dim toReturn As New ModuleActionCollection
                If BusinessController.IsLuceneProviderInstalled Then
                    Me.pnMain.Visible = True
                    toReturn.Add(GetNextActionID, Localization.GetString("ResultsSettings.Title", Me.LocalResourceFile), ModuleActionType.AddContent, "", _
                                 "icon_sitesettings_16px.gif", EditUrl("ResultSettings"), _
                                False, SecurityAccessLevel.Edit, True, False)
                    toReturn.Add(GetNextActionID, Localization.GetString("IndexerSettings.Title", Me.LocalResourceFile), _
                                ModuleActionType.AddContent, "", "icon_hostsettings_16px.gif", EditUrl("IndexerSettings"), _
                                False, SecurityAccessLevel.Admin, True, False)
                    toReturn.Add(GetNextActionID, Localization.GetString("Uninstall.Title", Me.LocalResourceFile), _
                                ModuleActionType.AddContent, "", "stop.gif", EditUrl("InstallUninstall"), _
                                False, SecurityAccessLevel.Host, True, False)

                Else
                    Me.pnMain.Visible = False
                    toReturn.Add(Me.GetNextActionID, Localization.GetString("Install.Title", Me.LocalResourceFile), _
                                  ModuleActionType.AddContent, "", "~/images/rec.gif", EditUrl("InstallUninstall"), _
                                  False, SecurityAccessLevel.Host, True, False)
                End If
                Return toReturn
            End Get
        End Property

#End Region
    End Class

End Namespace
