﻿Imports DotNetNuke.Services.Scheduling
Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Services.Search
Imports DotNetNuke.Entities.Portals

Namespace Aricie.DNN.Modules.LuceneSearch.Business.Scheduling
    Public Class ScheduledIndexation
        Inherits SchedulerClient

        Public Sub New(objScheduleHistoryItem As ScheduleHistoryItem)
            MyBase.ScheduleHistoryItem = objScheduleHistoryItem
        End Sub

        Public Overrides Sub DoWork()
            Try
                Progressing()
                Status = "Currently indexing data"
                Dim searchItemInfoCollection As New SearchItemInfoCollection()
                Dim portalController As New PortalController
                Dim LSD As New LuceneSearchDataStore()
                For Each portalInformation As PortalInfo In portalController.GetPortals()
                    Status = "Indexing portal " & portalInformation.PortalName
                    ScheduleHistoryItem.AddLogNote("Indexing portal " & portalInformation.PortalName)
                    LSD.StoreSearchItems(LuceneIndexer.RetrieveSearchIndexItems(portalInformation.PortalID))
                Next
                Status = "Data indexation done"
                ScheduleHistoryItem.Succeeded = True
                ScheduleHistoryItem.AddLogNote("Data indexation done")
            Catch ex As Exception
                ScheduleHistoryItem.Succeeded = False
                ScheduleHistoryItem.AddLogNote("Data indexation failed: " + ex.Message)
                ScheduleHistoryItem.AddLogNote("Location: " + ex.StackTrace)
                Errored(ex)
                Exceptions.LogException(ex)
            End Try
        End Sub
    End Class
End Namespace