Imports System.IO
Imports Aricie.Collections
Imports System.Globalization
Imports Lucene.Net.Analysis
Imports DotNetNuke.Services.Exceptions
Imports Lucene.Net.Index
Imports Lucene.Net.Documents
Imports DotNetNuke.Services.Search
Imports Aricie.DNN.Services
Imports Aricie.Services
Imports Lucene.Net.Analysis.Standard
Imports Lucene.Net.Search
Imports DocumentSink = System.Collections.Generic.Dictionary(Of Aricie.DNN.Modules.LuceneSearch.Business.IndexingItemStatus,  _
                                                             System.Collections.Generic.Dictionary(Of String, Lucene.Net.Documents.Document))
Imports Lucene.Net.QueryParsers

Namespace Aricie.DNN.Modules.LuceneSearch.Business



    Public Class PortalIndexingDriver
        Inherits PortalDriverBase


#Region "Actions"
        Private _Actions As New List(Of StoringIndexActions.Interface.IStoringIndexAction)
#End Region

#Region "ctor"

        Public Shared Function GetCurrent() As PortalIndexingDriver
            Return GetByPortalId(NukeHelper.PortalId)
        End Function

        Public Shared Function GetByPortalId(ByVal portalId As Integer) As PortalIndexingDriver
            Dim toreturn As PortalIndexingDriver = GetGlobal(Of PortalIndexingDriver)(portalId.ToString)
            If toreturn Is Nothing Then
                toreturn = New PortalIndexingDriver(portalId)
                SetGlobal(Of PortalIndexingDriver)(toreturn, portalId.ToString)
            End If
            Return toreturn

        End Function


        Private Sub New(ByVal portalId As Integer)

            MyBase.New(portalId)
            ' si on jour on veut rebrancher le backup, ractiver cette action
            ' _Actions.Add(New StoringIndexActions.BackupIndexAction())

        End Sub



#End Region

#Region "Public methods"

        Public Sub StoreSearchItems(portalid As Integer, SearchItems As SearchItemInfoCollection, logsteps As Boolean)
            Try
                _Actions.ForEach(Sub(a) a.BeforeStorage(Me))

                Dim luceneDataStore As LuceneSearchDataStore = DirectCast(SearchDataStoreProvider.Instance, LuceneSearchDataStore)
                If luceneDataStore Is Nothing Then
                    Throw New ApplicationException("Wrong DataStore")
                End If

                Dim CurrentlyExistingIndexStructure As Components.Lucene.ExistingIndex.ExistingIndexStructure(Of Components.Lucene.ExistingIndex.ExistingIndexDocument) = Nothing
                Using currentIndexQueryResults As LuceneQueryResults = luceneDataStore.GetCurrentIndex(portalid)
                    CurrentlyExistingIndexStructure = New Components.Lucene.ExistingIndex.ExistingIndexStructure(Of Components.Lucene.ExistingIndex.ExistingIndexDocument)(currentIndexQueryResults)
                End Using
                Using IM As New Components.Lucene.IndexMerger.IndexMerger(Me)
                    IM.MergeNewItemsWithExistingIndexStructure(SearchItems, CurrentlyExistingIndexStructure)
                End Using

                _Actions.ForEach(Sub(a) a.AfterStorage(Me))
            Catch ex As Exception
                ExceptionHelper.LogException(ex)
            End Try

        End Sub

#End Region

    End Class
End Namespace


