Imports Aricie.DNN.Modules.LuceneSearch.Business
Imports DotNetNuke.Services.Localization
Imports Lucene.Net.Index
Imports Lucene.Net.Search
Imports DotNetNuke.Entities.Modules

Namespace Aricie.DNN.Modules.LuceneSearch.UI
    Partial Public Class DesktopModuleLightFilter
        Inherits LuceneFilterControlBase


        Public Const glbAllDomains As String = "AllDomains"

#Region "Properties"

        Public Overrides Property Enabled() As Boolean
            Get
                Return Me.optSearchDomain.Enabled
            End Get
            Set(ByVal value As Boolean)
                Me.optSearchDomain.Enabled = value
            End Set
        End Property
#End Region

#Region "Event Handlers"

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
            If Not Me.IsPostBack Then
                Me.BindLayout()
            End If
        End Sub


#End Region

        Public Sub New()
            QueryMode = UI.QueryMode.Filter
        End Sub

#Region "ILuceneFilterControl implements"

        Public Overrides Function GetFilter() As LuceneFilterQuery
            Dim toReturn As New LuceneFilterQuery
            Dim domainValue As String = BusinessController.FormatSearchCriteria(Me.optSearchDomain.SelectedValue)
            Dim domainFilter As New TermQuery(New Term(DnnSearchItemField.ModuleName, domainValue))
            toReturn.FilterQuery = domainFilter
            Return toReturn
        End Function

        Public Overrides Function HasFilter() As Boolean
            Return Me.optSearchDomain.Items.Count >= 1 AndAlso Me.optSearchDomain.SelectedIndex <> 0
        End Function


        Public Overrides Function GetFieldNames() As IEnumerable(Of String)
            Return New String() {DnnSearchItemField.ModuleName}
        End Function

        Public Overrides Function ParseFilter(ByVal objFilter As LuceneFilterQuery) As Boolean
            If TypeOf objFilter.FilterQuery Is TermQuery Then
                Dim objTerm As Term = DirectCast(objFilter.FilterQuery, TermQuery).Term()
                If objTerm.Field = DnnSearchItemField.ModuleName Then
                    Dim domainValue As String = BusinessController.GetTermText(objTerm)
                    If Me.SetDomain(domainValue) Then
                        Return True
                    End If
                End If
            End If
            Return False
        End Function


        Public Function SetDomain(ByVal domainName As String) As Boolean
            For Each locItem As ListItem In optSearchDomain.Items

                If locItem.Value = domainName Then
                    Me.optSearchDomain.SelectedValue = domainName
                    Return True
                End If
            Next
            Return False
        End Function


#End Region

#Region "Private methods"

        Private Sub BindLayout()

            Dim values As New ArrayList


            'On get tous les desktopmodule Isearchable:
            Dim objDkModoController As New DesktopModuleController()
            Dim arrDesktopModules As ArrayList = objDkModoController.GetDesktopModulesByPortal(PortalSettings.PortalId)
            For Each myDkModule As DesktopModuleInfo In arrDesktopModules
                'seulement ceux qui ont un provider d'indexation lucene
                'If Not (myProviderFactory.getProviderFromModuleName(myDkModule.ModuleName) Is Nothing) Then
                'Seulement ceux qui sont slectionns pour etre searchable
                'If (PortalSettings.GetSiteSetting(Me.PortalId, myDkModule.ModuleName) = Constants.MODULEAVAILABLEFORSEARCH) Then 'Lucene.SearchProvider.
                If PortalIndexingDriver.GetCurrent.LucenePortalSettings.IsAvailableForSearching(myDkModule.ModuleName) _
                    Then

                    Dim locItemtext As String = Localization.GetString(myDkModule.ModuleName, Me.LocalResourceFile)
                    Dim newItem As ListItem = New ListItem()
                    newItem.Value = myDkModule.ModuleName
                    If String.IsNullOrEmpty(locItemtext) OrElse locItemtext.ToLower.StartsWith("resx:") Then
                        newItem.Text = myDkModule.FriendlyName
                    Else
                        newItem.Text = locItemtext
                    End If
                    values.Add(newItem)

                End If
                'End If
            Next


            If values.Count <= 1 Then
                optSearchDomain.Visible = False
            Else
                'On rajoute l'option "tous les domaines" s'il y en a plus d'un de disponible 
                Dim _
                    allDomainItem As _
                        New ListItem( _
                                      Localization.GetString(glbAllDomains, _
                                                              Localization.GetResourceFile(Me, MyFileName)), _
                                      glbAllDomains)
                values.Insert(0, allDomainItem)

                'rcuprer le nom de recherche sur tout le portail/tous les domaines dans les settings du module de recherche
                'Dim searchModule As ModuleInfo = objModules.GetModuleByDefinition(PortalSettings.PortalId, "Aricie.LuceneSearch")
                'Dim locSettings As System.Collections.Hashtable = objModules.GetModuleSettings(locModule.ModuleID)
                'If locSettings.ContainsKey("NameChoixAllDomains") Then

                '    allDomainItem.Text = locSettings("NameChoixAllDomains")

                'End If


                'TODO: comprendre pourquoi il perd parfois le controle optsearchdomain, imposant ainsi une recompilation avec les deux ligtnes 
                'suivantes commentes, pour pouvoir dse connecter et re-parser la skin et ensuite recompiler avec ces deux lignes dcommenter et enfin a marche...

                optSearchDomain.DataSource = values
                optSearchDomain.DataBind()

            End If


        End Sub

#End Region
    End Class
End Namespace
