Imports Aricie.DNN.Modules.LuceneSearch.Business
'Imports DotNetNuke.Modules.Forum
Imports Aricie.DNN.Services
Imports DotNetNuke.Entities.Portals
Imports DotNetNuke.Services.FileSystem
Imports System.Globalization
Imports DotNetNuke.Services.Search

Namespace Aricie.DNN.Modules.LuceneSearch.ModuleProviders
    Public Class ForumProvider
        Implements ILuceneSearchableUpgrade
        Implements DotNetNuke.Entities.Modules.ISearchable

        Private Shared ReadOnly ModuleSettingName As String = "LastIndexDate"

#Region "Implement ILuceneSearchableUpgrade"
        Public Sub UpgradeSearchItem(ByVal portalId As Integer, ByRef searchItem As LuceneSearchItemInfo) _
            Implements ILuceneSearchableUpgrade.UpgradeSearchItem
            ' on ne va pas faire de traitement si jamais on a un objet qui a t skipp
            If (searchItem.IndexingStatus = IndexingItemStatus.Skipped) Then
                Exit Sub
            End If
            Dim postId As Integer = Integer.Parse(searchItem.SearchKey)

            'Aricie.Services.ReflectionHelper.CreateObject(searchItem.ModuleInfo.BusinessControllerClass)

            'Dim post As PostInfo = Me.PostCtlr.PostGet(postId, GetPortalIdByModuleId(searchItem.ModuleId))
            'If post.FileAttachmentURL <> "" Then

            '    Dim pc As New PortalController
            '    Dim portal As PortalInfo = pc.GetPortal(portalId)
            '    Dim fileInfo As FileInfo = GetFileInfoFromCtrUrl(portalId, post.FileAttachmentURL)
            '    If Not fileInfo Is Nothing Then

            '        Dim filePath As String = fileInfo.PhysicalPath
            '        searchItem.AdditionalFields = DocumentController.GetDocumentFromFile(filePath, False)

            '        Dim factory As FieldFactory = FieldFactory.Instance
            '        searchItem.AdditionalFields.Add(factory.CreateField(LuceneGeneralField.ItemId, post.PostID.ToString(CultureInfo.InvariantCulture)))

            '    End If
            'End If
        End Sub
#End Region


        Public Function GetSearchItems(ModInfo As DotNetNuke.Entities.Modules.ModuleInfo) As DotNetNuke.Services.Search.SearchItemInfoCollection Implements DotNetNuke.Entities.Modules.ISearchable.GetSearchItems
            ' pour rechercher dans le forum, on va rcuprer la date de dernire indexation du module dans les settings
            Dim moduleController As New DotNetNuke.Entities.Modules.ModuleController
            Dim selectionDate As DateTime = DotNetNuke.Common.Utilities.Null.NullDate
            Dim latestIndexationDate As DateTime = DotNetNuke.Common.Utilities.Null.NullDate
            Dim currentIndexationDate As DateTime = DateAndTime.Now

            Dim CurrentProvider As String = [GetType]().Name

            Dim moduleSettings As Hashtable = moduleController.GetModuleSettings(ModInfo.ModuleID)
            If moduleSettings(ModuleSettingName) IsNot Nothing Then
                Try
                    Dim n As Double = Microsoft.VisualBasic.CompilerServices.Conversions.ToDouble(moduleSettings(ModuleSettingName))
                    latestIndexationDate = DateTime.FromOADate(n)
                Catch ex As Exception
                    ' on ne peut rien faire s'il y a un problme ici et on va garder notre date initiale
                End Try
            End If
            ' une fois tous ces paramtres rcuprs, on va changer la date de dernire indexation du forum pour qu'il nous renvoie tous les lments
            moduleController.UpdateModuleSetting(ModInfo.ModuleID, ModuleSettingName, selectionDate.ToOADate().ToString)

            Dim FinalResults As New SearchItemInfoCollection
            Dim Controller As DotNetNuke.Entities.Modules.ISearchable = TryCast(Aricie.Services.ReflectionHelper.CreateObject(ModInfo.BusinessControllerClass), DotNetNuke.Entities.Modules.ISearchable)
            If Controller IsNot Nothing Then
                Dim TemporaryResults As SearchItemInfoCollection = Controller.GetSearchItems(ModInfo)

                For Each sii As SearchItemInfo In TemporaryResults
                    Dim lsii As LuceneSearchItemInfo = LuceneSearchItemInfo.GetLuceneSearchItem(sii, ModInfo.PortalID, CurrentProvider)
                    If sii.PubDate < latestIndexationDate Then
                        lsii.IndexingStatus = IndexingItemStatus.Skipped
                    Else
                        lsii.IndexingStatus = IndexingItemStatus.Ok
                    End If
                    FinalResults.Add(lsii)
                Next
            End If

            ' une fois tous ces paramtres rcuprs, on va changer la date de dernire indexation du forum pour qu'il nous renvoie tous les lments
            moduleController.UpdateModuleSetting(ModInfo.ModuleID, ModuleSettingName, currentIndexationDate.ToOADate().ToString)

            Return finalResults
        End Function

    End Class
End Namespace

