Imports Aricie.DNN.Modules.LuceneSearch.Business
Imports DotNetNuke.UI.Skins.Controls
Imports DotNetNuke.UI.Skins
Imports Aricie.DNN.Services
Imports DotNetNuke.Services.Localization
Imports DotNetNuke.Common.Globals
Imports Aricie.Web.UI
Imports DotNetNuke.UI.Utilities
Imports DotNetNuke.Entities.Modules
Imports Aricie.DNN.Modules.LuceneSearch.Settings
Imports DotNetNuke.Common.Utilities
Imports Lucene.Net.Search
Imports Aricie.DNN.Settings
Imports LSCommon = Aricie.DNN.Modules.LuceneSearch.Common
Imports Aricie.Services
Imports System.Reflection

Namespace Aricie.DNN.Modules.LuceneSearch.UI

    Partial Public Class SearchSkinObject
        Inherits SkinObjectBase

        Const MyFileName As String = "SearchSkinObject.ascx"
        Private Const FILTER_PATH As String = "./Controls/DEsktopModuleLightFilter.ascx"

#Region "Private members"
        Private _luceneSettings As LuceneResultsSettings
        Private _searchModule As ModuleInfo
        'Private _submitImageURL As String

#End Region

#Region "Public Members"

        Public Property ResultsTabId() As Integer = -1
        Public Property UseLanguageFilter() As Boolean = True
        Public Property Submit() As String
        Public Property CssClass() As String
        Public Property ShowFilter() As Boolean = True
        Public Property DisableFuzzyRatio() As Boolean = False
        Public Property SubmitImageURL() As String

        Public Property IncludeSkinObjectCSS() As Boolean = False
        Public Property SkinObjectCSS() As String = "SkinObject.css"

        Private _LocalResourceFile As String

        Public Property LocalResourceFile() As String
            Get
                If String.IsNullOrEmpty(Me._LocalResourceFile) Then
                    Me._LocalResourceFile = NukeHelper.GetModuleSharedResourceFile(BusinessController.LuceneSearchResultsDefId)
                End If
                Return Me._LocalResourceFile
            End Get
            Set(ByVal value As String)
                Me._LocalResourceFile = value
            End Set
        End Property

        Private ReadOnly Property searchModule() As ModuleInfo
            Get
                If _searchModule Is Nothing Then
                    _searchModule = NukeHelper.ModuleController.GetModuleByDefinition(PortalSettings.PortalId, Common.Constants.ModuleNameLuceneSearchResults)
                    If _searchModule Is Nothing Then
                        Skin.AddPageMessage(Me.Page, Localization.GetString("NoSearchModule.Heading", Me.LocalResourceFile), _
                                            Localization.GetString("NoSearchModule", Me.LocalResourceFile), ModuleMessage.ModuleMessageType.YellowWarning)
                    End If
                End If
                Return _searchModule
            End Get
        End Property

        Private ReadOnly Property LucenSettings() As LuceneResultsSettings
            Get
                If _luceneSettings Is Nothing Then
                    _luceneSettings = PortalQueryingDriver.GetCurrent.LuceneResultsSettings(searchModule.ModuleID)
                End If
                Return _luceneSettings
            End Get
        End Property

        Private ReadOnly Property LucenePortalSettings() As LucenePortalSettings
            Get
                Return GetModuleSettings(Of LucenePortalSettings)(SettingsScope.PortalSettings, PortalSettings.PortalId)
            End Get
        End Property

        Public Property DisplayAdvancedSearch As Boolean

        Public ReadOnly Property SearchResultsTabId As Integer
            Get
                If ResultsTabId <> -1 Then
                    Return ResultsTabId
                ElseIf LucenSettings.ResultsTabId <> -1 Then
                    Return LucenSettings.ResultsTabId
                Else
                    Return searchModule.TabID
                End If
            End Get
        End Property

#End Region

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

            Try

                If Not Page.IsPostBack Then

                    Dim lucenePortalSetts As LucenePortalSettings = Nothing
                    Try
                        lucenePortalSetts = LucenePortalSettings
                    Catch ex As Exception

                        Visible = False
                        Exit Sub
                    End Try




                    ctlFilterPanel.MakeLog = lucenePortalSetts.EnableFilterLogging

                    Me.ctlFilterPanel.Visible = Me.ShowFilter
                    If Me.ShowFilter Then
                        Dim filterControl As DesktopModuleLightFilter = DirectCast(LoadControl(FILTER_PATH), DesktopModuleLightFilter)
                        Me.ctlFilterPanel.Controls.Add(filterControl)
                    End If

                    'Labels search
                    lblSearch.Text = Localization.GetString("lblSearch.Text", Localization.GetResourceFile(Me, MyFileName))
                    '"All Portal"

                    ClientAPI.RegisterKeyCapture(Me.txtSearch, FindControlsRecursive(Of LinkButton)(Me.cmdSearch)(0), Asc(vbCr))

                    If Submit <> "" Then
                        If Submit.IndexOf("src=") <> -1 Then
                            Submit = Replace(Submit, "src=""", "src=""" & PortalSettings.ActiveTab.SkinPath)
                        End If
                        cmdSearch.Text = Submit
                        cmdSearch.DisplayLink = True
                        cmdSearch.DisplayIcon = False
                    End If

                    If Not String.IsNullOrEmpty(SubmitImageURL) Then
                        cmdSearch.ImageUrl = SubmitImageURL
                    End If

                    If CssClass <> "" Then
                        cmdSearch.CssClass = CssClass
                    End If

                    txtSearch.Text = BusinessController.HttpCriteriaSring
                    ' si on est en autocomplete et qu'il n'y a aucun filtre, nous avons sans doute utilis une recherche par prfixe. Le cas chant, il faut nous en dbarasser 
                    If LucenePortalSettings.Autocomplete.EnableAutoComplete AndAlso (Not LucenSettings.FiltersDisplayed) Then
                        If txtSearch.Text.EndsWith("*") Then
                            txtSearch.Text = txtSearch.Text.Substring(0, txtSearch.Text.Length - 1)
                        End If
                    End If

                    ' affichons l'advancedSearch
                    hlAdvancedSearch.Visible = DisplayAdvancedSearch
                    If DisplayAdvancedSearch Then
                        'si on doit l'afficher, il faut renvoyer sur la bonne url
                        hlAdvancedSearch.NavigateUrl = (BusinessController.GetSearchUrl(SearchResultsTabId, String.Empty))
                        hlAdvancedSearch.Text = Localization.GetString("hlAdvancedSearch.Text", Localization.GetResourceFile(Me, MyFileName))
                    End If
                End If

                ' branchons l'extend
                AutoCompleteExtend()

                ' rajoutons la css automatiquement si c'est demand
                ' http://stackoverflow.com/questions/3876601/asp-net-custom-control-what-is-the-best-way-to-include-embedded-css-reference
                If (IncludeSkinObjectCSS AndAlso Not String.IsNullOrEmpty(SkinObjectCSS)) Then
                    Dim ResolvedCSSUrl = ResolveUrl(SkinObjectCSS)
                    If Not Page.ClientScript.IsClientScriptBlockRegistered("ALSSSkinobjectCSS." + ID) Then
                        Dim cssLink = New HtmlLink() With {.Href = ResolvedCSSUrl}
                        cssLink.Attributes.Add("rel", "stylesheet")
                        cssLink.Attributes.Add("type", "text/css")
                        Page.Header.Controls.Add(cssLink)
                        Page.ClientScript.RegisterClientScriptBlock(GetType(System.Web.UI.Page), "ALSSSkinobjectCSS." + ID, String.Empty)
                    End If
                End If

            Catch ex As Exception
                'DotNetNuke.UI.Skins.Skin.AddModuleMessage(me, "Erreur non traite dans le skin object de recherche. Il faut probablement re-analyser la skin", DotNetNuke.UI.Skins.Controls.ModuleMessage.ModuleMessageType.RedError);
                Skin.AddPageMessage(Me.Page, "Skin object error", ex.Message & _
                                     "Erreur non traite dans le skin object de recherche. Il faut probablement re-analyser la skin", _
                                     ModuleMessage.ModuleMessageType.RedError)
            End Try

        End Sub

        ''' <summary>
        ''' Manages the scripts and events for Autocompletion
        ''' </summary>
        ''' <remarks></remarks>
        Private Sub AutoCompleteExtend()
            Dim ACS As AutoComplete = LucenePortalSettings.Autocomplete

            If ACS.EnableAutoComplete Then
                ' on embarque notre JS
                ScriptManager.RegisterClientScriptInclude(Me, ACS.GetType, Me.ID, ResolveUrl("~/DesktopModules/Aricie.LuceneSearch/WebService/client/script/AutoComplete.js"))

                Dim wsPath = ResolveUrl("~/DesktopModules/Aricie.LuceneSearch/WebService/Aricie.LS.AutocompleteSvc.asmx/GetAutocompleteItems") & "?PortalId=" & PortalId

                Dim textboxId = txtSearch.ClientID
                Dim minChars = ACS.CharsForCompletion
                Dim groupName = IIf(ACS.EnableGrouping, ACS.GroupName, String.Empty)

                Dim JSONSerializer = New Script.Serialization.JavaScriptSerializer()
                Dim ScriptManagementConfig As String = JSONSerializer.Serialize( _
                    New With { _
                        .includeScriptAndStyle = ACS.IncludeScriptAndStyle, _
                        .jQueryJSUrl = ACS.jQueryJSUrl, _
                        .jQueryUIJSUrl = ACS.jQueryUIJSUrl, _
                        .crushjQueryUI = ACS.CrushJQueryUI, _
                        .jQueryUICSSUrl = ACS.jQueryUICSSUrl _
                    } _
                )
                Dim AutocompleteConfig As String = JSONSerializer.Serialize( _
                    New With { _
                        .targetId = textboxId _
                        , .minlength = minChars _
                        , .webservice = wsPath _
                        , .displayHeader = ACS.DisplayHeader _
                        , .headerTemplate = ACS.HeaderText _
                        , .group = ACS.DisplayGroupName _
                        , .groupBy = groupName _
                        , .groupingTemplate = ACS.CategoryTemplate _
                        , .itemTemplate = ACS.ItemTemplate _
                        , .noAnswerTemplate = ACS.NoAnswer _
                        , .showHighlights = ACS.EnableHighlights _
                        , .enableCustomPosition = ACS.EnableCustomPosition _
                        , .customPosition = ACS.CustomPosition _
                        , .defaultPosition = AutoComplete.CustomPositionDefault _
                        , .customWindowing = "try { " & ACS.OpenInNewWindow & "} catch (exc) {return null;}"
                    } _
                )

                'TODO: Revenir sur cet lment. Le JavascriptSerializer ne sait pas faire autre chose que de l'utf 8 donc il 
                ' casse un peu notre template. Je refais le passage en sens inverse pour lui forcer la main
                AutocompleteConfig = AutocompleteConfig.Replace("\u003c", "<").Replace("\u003e", ">")


                Dim script As String = String.Format("AricieLuceneSearchAutocomplete.Init({0}, {1} );", ScriptManagementConfig, AutocompleteConfig)
                ScriptManager.RegisterStartupScript(Me, LucenePortalSettings.Autocomplete.GetType(), "Init" & Now.Ticks.ToString(), script, True)

                AddCSS("AutoCompleteCustom", ResolveUrl("~/DesktopModules/Aricie.LuceneSearch/Webservice/client/style/AutoComplete.css"))
            End If
        End Sub

        Private Sub AddCSS(ByVal cssId As String, ByVal url As String)
            If (Page IsNot Nothing) AndAlso (Page.Header IsNot Nothing) Then
                If Page.Header.FindControl(cssId) Is Nothing Then
                    Dim lnk As New HtmlControls.HtmlLink
                    lnk.ID = cssId
                    lnk.Href = Page.ResolveUrl(url)
                    lnk.Attributes.Add("type", "text/css")
                    lnk.Attributes.Add("rel", "stylesheet")
                    Page.Header.Controls.Add(lnk)
                End If
            End If
        End Sub

        ''' <summary>
        ''' Submit the search query (by default use an approximate search)
        ''' </summary>
        Private Sub cmdSearch_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdSearch.Click

            Try
                'benoit: enable search phrase exacte with quotes
                Dim strSearchText As String = txtSearch.Text.Trim()
                Dim textToSearch As String = ""
                If strSearchText.StartsWith("""") And strSearchText.EndsWith("""") Then
                    textToSearch = strSearchText
                Else
                    Dim toCleanOut As String = """ "
                    Dim words() As String = txtSearch.Text.TrimStart(toCleanOut.ToCharArray()).TrimEnd(toCleanOut.ToCharArray()).Split(" "c)

                    For Each word As String In words
                        'benoit: enable mots clef OR et AND
                        If word = "OR" Or word = "AND" Then
                            textToSearch &= word & " "
                        Else
                            'benoit: la valeur de floutage se rcupre depuis les settings du MODULE search                           
                            'On vrifie qu'on a check recherche floue dans les settings

                            If Not DisableFuzzyRatio Then
                                Dim myFloutage As String
                                myFloutage = (LucenSettings.DefaultFuzzyValue / 100).ToString
                                If myFloutage Is Nothing Or myFloutage = "0" Then
                                    myFloutage = "1"
                                End If

                                Dim RechercheFloue As Boolean = myFloutage <> "1"


                                If RechercheFloue Then
                                    textToSearch &= word & "~" & myFloutage
                                    '"~0.9 "
                                Else
                                    textToSearch &= word & " "
                                End If
                            Else
                                textToSearch &= word & " "
                            End If

                        End If

                    Next
                End If
                textToSearch = textToSearch.Trim()
                Dim filter As String = ""
                If Me.ctlFilterPanel.HasFilter Then
                    Dim filterQuery As BooleanQuery
                    Dim objFilter As LuceneFilterQuery = Me.ctlFilterPanel.GetFilter()
                    filterQuery = DirectCast(objFilter.FilterQuery, BooleanQuery)


                    If Me.UseLanguageFilter Then
                        filterQuery.Add(BusinessController.GetCurrentLocaleQuery, Occur.MUST)
                    End If
                    filter = filterQuery.ToString
                End If

                ' si on est en autocomplete, et qu'aucun filtre n'est affich sur la page de recherche avance, il va falloir utiliser la recherche par prfixe
                If LucenePortalSettings.Autocomplete.EnableAutoComplete AndAlso (Not LucenSettings.FiltersDisplayed) Then
                    ' mais si on a dj une toile, on ne la rajoute pas
                    If Not textToSearch.EndsWith("*") Then
                        textToSearch += "*"
                    End If
                End If

                Dim retidrectUrl As String = BusinessController.GetSearchUrl(SearchResultsTabId, textToSearch, filter)

                Response.Redirect(retidrectUrl)

            Catch ex As Exception
                Skin.AddPageMessage(Me.Page, "Skin object error", ex.Message, ModuleMessage.ModuleMessageType.RedError)
            End Try

        End Sub

        Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
            If Context IsNot Nothing AndAlso Context.Session IsNot Nothing Then
                If Session(LSCommon.Constants.LS_SEARCHTABID) IsNot Nothing Then

                    Dim objLuceneSettings As LuceneResultsSettings = PortalQueryingDriver.GetCurrent.LuceneResultsSettings(CInt(Session(LSCommon.Constants.LS_SEARCHTABID).ToString.Split(";"c)(1)))
                    If objLuceneSettings.DisplayBackButton AndAlso Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) IsNot Nothing AndAlso Request.Params(LSCommon.Constants.UrlParameters.LuceneSearchModeParameter) = "detail" Then
                        Dim objCtl As Control = Me.Parent.FindControl("ContentPane")
                        Dim objBackButton As New Literal
                        Dim strBackButtonTemplate As String = objLuceneSettings.BackButtonTemplate
                        strBackButtonTemplate = strBackButtonTemplate.Replace("[BACK_LINK_URL]", NavigateURL(CInt(Session(LSCommon.Constants.LS_SEARCHTABID).ToString.Split(";"c)(0)), "", LSCommon.Constants.UrlParameters.LuceneSearchModeParameter & "=back"))
                        strBackButtonTemplate = strBackButtonTemplate.Replace("[BACK_LINK_LIB]", Localization.GetString("BackButton.Text", Me.LocalResourceFile))
                        objBackButton.Text = strBackButtonTemplate
                        objCtl.Controls.AddAt(0, objBackButton)
                    End If
                End If
            End If
        End Sub
    End Class

End Namespace
